<'

define <item_constraint_imp'statement> "item_constraint_imp <seq'name>\(<item'name>\).<attr'name> {<constraint>;...}[ with context {<struct_member>;...}]" as {
    
    extend <item'name> {
        <attr'name>: bool;
        keep <attr'name> == in_sequence(<attr'name> <seq'name>);
        when <attr'name> <item'name> {
            context: <attr'name> <seq'name>;
            keep in_sequence(<attr'name> <seq'name>) (seq) => context == seq;
            keep all of {
                <constraints>;
            };
        };
    };
    
    extend <seq'name> {
        <attr'name>: bool;
        keep soft not <attr'name>;
        when <attr'name> <seq'name> {
            <struct_members>;
        };
    };    
};

extend rf_struct {
    get_my_sequence_type(): rf_bfm_sequence is {
        for each rf_bfm_sequence (seq) in rf_manager.get_all_sequences() do {
            if seq.get_item_struct() == me {
                return seq;
            };
        };
    };
};

define <item_constraint'statement> "item_constraint <item'name>.<attr'name> <any>" as computed {
    var item_struct: rf_struct = rf_manager.get_type_by_name(<item'name>).as_a(rf_struct);
    var seq_name: string = item_struct.get_my_sequence_type().get_name();
    return appendf("item_constraint_imp %s(%s).%s %s",seq_name,<item'name>,<attr'name>,<any>);
};

define <sequence_export'statement> "sequence_export <item'name>[ ]:[ ]<name>,..." as computed {
    var code: list of string;
    var item_struct: rf_struct = rf_manager.get_type_by_name(<item'name>).as_a(rf_struct);
    var seq_name: string = item_struct.get_my_sequence_type().get_name();
    for each (field_name) in <names> do {
        var attr_name: string = appendf("push_%s",field_name);
        var field_decl: string = appendf("%s: %s",field_name,item_struct.get_field(field_name).get_type().get_name());
        var val_constraint: string = appendf("%s == context.%s",field_name,field_name);
        code.add(appendf("item_constraint_imp %s(%s).%s { %s } with context { %s }",seq_name,<item'name>,attr_name,val_constraint,field_decl));
    };
    code.push0("{"); code.push("}"); // required for SN versions < 6.2
    result = str_join(code,";");
};

'>
