Sequence Definitions
<'

struct packet like any_sequence_item {
    addr: uint(bits: 8);
    data: uint(bits: 64);
    do_print() is {
        out(me);
        print addr using hex;
        print data;
        out();
    };
};

sequence packet_seq using item = packet;

unit bfm {
    driver : packet_seq_driver is instance;
    
    event clock is @sys.any;
    
    on clock {
        emit driver.clock;
    };
    
    work() @clock is {
        while TRUE {
            first of {
                {
                    print driver.get_next_item();
                    emit driver.item_done;
                    wait [1];
                };
                {
                    wait [10];
                    stop_run();
                };
            };
        };
    };
    
    run() is also {
        start work();
    };
};

extend sys {
    bfm is instance;
};

'>

Sequence Library

<'
extend packet_seq_kind: [LEVEL_1, LEVEL_2];

extend LEVEL_1 packet_seq {
    !item: packet;
    body() @driver.clock is {
        do item;
    };
};

extend LEVEL_2 packet_seq {
    !sub_seq: LEVEL_1 packet_seq;
    body() @driver.clock is {
        for i from 1 to 4 do {
            do sub_seq;
        };
    };
};

'>
